

function [star] = fastar_F_GVS_3_unb_filter_ffr(draw,priors,data)
%   *******************************************************
%   *******************************************************
%   The covariance matrix of the measurement equation
R_a = blkdiag(zeros(priors.N,priors.N),diag(draw.sig));
%   *******************************************************
%   *******************************************************
%   Parameters of the state space model
FF = [eye(priors.dim_x - priors.N - 1) , zeros(priors.dim_x - priors.N - 1,priors.N + 1)];
N_c = (priors.N + 1) * (priors.P - 1);
H1 = [eye(priors.N) , zeros(priors.N,1) , zeros(priors.N,N_c)];
H2 = [zeros(priors.N_x,priors.N-1) , draw.beta(:,2), draw.beta(:,1).* draw.lam, zeros(priors.N_x,N_c)];
H = [H1;H2];
OMEGA_p=[draw.OMEGA zeros(priors.N + 1,priors.dim_x - priors.N - 1); zeros(priors.dim_x - priors.N - 1,priors.dim_x)]; % new line
draw.sc=std(draw.F(:,20:end),1,2);
%draw.sc=priors.sc; 

%   *******************************************************
%   *******************************************************
%   Initialize the filter
%   Do we want to optimize the starting values?
x_tm1_tm1 = normrnd(0,1,priors.dim_x,1);
P_tm1_tm1 = eye(priors.dim_x);
%   Storage
F_T = zeros(priors.dim_x,priors.dim_x,priors.T);
x = zeros(priors.dim_x,priors.T);
x_t_tm1_store = zeros(priors.dim_x,priors.T);
x_t_tm1=zeros(priors.dim_x,1);% new line 
P = zeros(priors.dim_x,priors.dim_x,priors.T);
P_t_tm1_store = zeros(priors.dim_x,priors.dim_x,priors.T);
%   *******************************************************--
%   Iterate
%   *******************************************************
for t = 1 : priors.T
    %   *******************************************************
    %   Predict
    %   *******************************************************
    exp_f = exp(-(draw.gamma/draw.sc) * (x_tm1_tm1(priors.N+1,:) - draw.c));
    pi_0 = 1 / (1 + exp_f);
    XX_tm1_tm1 = [1; x_tm1_tm1];
    x_t_tm1(1:priors.N+1,1) = (draw.A1 +  pi_0 * draw.A2) *  XX_tm1_tm1;
    x_t_tm1(priors.N+2:end,1) = FF * x_tm1_tm1; 
    %   Compute the Jacobian of F
    F_t =  draw.A1(:,2:end) +  pi_0 * draw.A2(:,2:end);
    F_t(:,priors.N+1) = F_t(:,priors.N+1)+ (exp_f *(-draw.gamma/draw.sc) * draw.A2(:,:)*XX_tm1_tm1(:)) / ((1+exp_f) ^ 2); %tnis is the effect of the factor on lag 1 only
    F_t=[F_t; FF]; %new line
    P_t_tm1 = F_t * P_tm1_tm1 * F_t' + OMEGA_p; 
    %   *******************************************************
    %   Update
    %   *******************************************************
    y_t = [data.Y(:,t);data.X(:,t)];
    %   *******************************************************
    %   ADD THIS FOR UNBALANCED PANEL
    %   *******************************************************
    %delta_y = zeros(size(y_t,1),1);
    %for nn = 1:size(y_t,1)
     %   if isnan(y_t(nn,1)) == 1
      %      delta_y(nn,1) = 0;
       % else
        %    delta_y(nn,1) = y_t(nn,1) - H(nn,:) * x_t_tm1;
        %end,
    %end,
    %if any(isnan(delta_y)) == 1
     %   error('delta_y')
    %end,
    H_w=H; 
    R_aw=R_a; 
    y_w=y_t; 
    for nn = 1:size(y_t,1)
        if isnan(y_t(nn,1)) == 1
            y_w(nn,1) = 0;
            H_w(nn,:) = zeros(1,priors.dim_x);
            R_aw(nn,:)= zeros(1,priors.N_x+priors.N); 
            R_aw(:,nn)= zeros(priors.N_x+priors.N,1); 
        end,
      
   end,
       delta_y = y_w - H_w * x_t_tm1;
    %   *******************************************************
    %   delta_y = y_t - H * x_t_tm1;
    %   *******************************************************
        S_t = H_w * P_t_tm1 * H_w' + R_aw;
    %if any(eig(S_t) < 0.0001)==1
     % error('singular warning')
    %end
    K_t = P_t_tm1 * H_w' * pinv(S_t);
    x_t_t = x_t_tm1 + K_t * delta_y;
    p_t_t=P_t_tm1-(K_t*S_t*K_t');
    P_t_t = p_t_t;
    %   *******************************************************
    %   Storage
    %   *******************************************************
    F_T(:,:,t) = F_t;%jacobian
    x(:,t) = x_t_t;%filtered state
    x_t_tm1_store(:,t) = x_t_tm1;%predicted state
    P(:,:,t) = P_t_t;%filtered state
    P_t_tm1_store(:,:,t) = P_t_tm1;%predicted state
    %   Step
    x_tm1_tm1 = x_t_t;
    P_tm1_tm1 = P_t_t;
end,
%   *******************************************************
%   SMOOTHING AND DRAWS
%   *******************************************************
XI = zeros(1,priors.T);
xi_t_T = zeros(priors.dim_x,priors.T);
xi_t_T(:,priors.T)=x(:,priors.T);
P_t_T = zeros(priors.dim_x,priors.dim_x,priors.T);
P_t_T(:,:,priors.T)=P(:,:,priors.T);

for t = priors.T-1:-1:1
    exp_f = exp(-(draw.gamma/draw.sc) *(x(priors.N+1,t) - draw.c));
    pi_0 = (1/(1+exp_f));
    xip_t =(draw.A1 + ( pi_0 * draw.A2)) *  [1; x(:,t)];
    xip_t=[xip_t; FF*x(:,t)]; 
    Fi_t =  draw.A1(:,2:end) +  pi_0 * draw.A2(:,2:end);
    Fi_t(:,priors.N+1) = Fi_t(:,priors.N+1)+ (exp_f *(-draw.gamma/draw.sc) * draw.A2(:,:)*[1; x(:,t)]) / ((1+exp_f) ^ 2); %jacobian based on filtered
    Fi_t=[Fi_t; FF];
    Pi_t_tm1 = Fi_t * P(:,:,t) * Fi_t' + OMEGA_p;
    J_t = P(:,:,t) * Fi_t' * pinv(Pi_t_tm1);
    dev_P_t = P_t_T(:,:,t+1) - Pi_t_tm1;
    P_t_T(:,:,t) = P(:,:,t) + J_t * dev_P_t * J_t';%smoothed state variance
    dev_x_t = xi_t_T(:,t+1) - xip_t;
    xi_t_T(:,t) = x(:,t) + J_t * dev_x_t; %smoothed state mean.
end,

XI = zeros(1,priors.T);
for t = 1:priors.T
     XI(:,t) = xi_t_T(priors.N+1,t);
end,

% % % % XI = zeros(1,priors.T);
% % % % for t = 1:priors.T
% % % %     XI(:,t) = x(priors.N+1,t) + chol(P(priors.N+1,priors.N+1,t)) * normrnd(0,1,1,1);
% % % % end,
%   *******************************************************
%   *******************************************************
%   This computes the lags of the factor and the values of transition function
%   *******************************************************
star.F = XI(1,:);
star.F_minus = normrnd(priors.f,sqrt(priors.F),1,priors.T+priors.P,priors.P);
for p = 1 : priors.P
    star.F_minus(:,p+1:priors.T+p,p) = star.F;
end,
star.F_minus = star.F_minus(:,1:priors.T,:);
star.sc=std(star.F_minus(:,5:end,1),1,2); 
star.phi_val = (1 + exp(-(draw.gamma/star.sc) * (star.F_minus(:,:,1) - draw.c * ones(1,priors.T)))) .^ (-1);
if any(abs(star.F) > 150) == 1
    error('f')
end

