function [priors,draw,data] = fastar_priors_GVS_unb_after(datanam)
%   ******************************************************************
%   Set up the sampler
%   ******************************************************************
priors.burn = 5000;
priors.keep = 20000;
priors.P = 1;
priors.H =48;
priors.Hf=12; %forecasting horizons
priors.datanam = datanam;
%   ******************************************************************
%   Load the data
data.Y = xlsread(priors.datanam,'Sheet2');
data.Y = data.Y(:,3:end)';
% % % [data,params] = make_FASTAR_data_a(2,1,400,30);
% % % data.Y = data.y;
[priors.N,T] = size(data.Y);
%   make lags of the data
data.Y_minus = zeros(priors.N,T,priors.P);
for p = 1:priors.P
    data.Y_minus(:,1+p:end,p) = data.Y(:,1:end-p);
end,
data.Y_minus = data.Y_minus(:,1+priors.P:end,:);
data.Y = data.Y(:,1+priors.P:end);
priors.T = size(data.Y,2);
priors.f = 0;
priors.F = 1;
data.x = xlsread(priors.datanam,'Sheet1');
data.x = data.x(:,3:end)';
data.X = data.x(:,1+priors.P:end);
priors.N_x = size(data.x,1);
priors.start_x = zeros(priors.N_x,1);
for n_x = 1:priors.N_x
    t_start = find(isnan(data.X(n_x,:)),1,'last');
    if isempty(t_start) == 1
        priors.start_x(n_x,1) = 1;
    else
        priors.start_x(n_x,1) = t_start + 1;
    end,
end,

%[draw.F,draw.beta] = pca(data.X',1);
%[draw.F,draw.beta] = pca(data.X(:,266:end)',1);
%[draw.F,draw.beta] = pca(data.X(:,101:end)',1);
draw.beta=[-2.4662;0.4608;0.11789;-0.48090;-3.20267;-1.921;-1.1704;-0.9732;-0.5484;-6.6579;-1.451;-0.328;-3.0784;
0.687;-9.555;-9.694;-8.292;-2.4348;-0.5;-1.186;-1.361;-12.502;-0.99];

draw.F=draw.beta'*data.X; 

draw.F = normrnd(priors.f,sqrt(priors.F),1,priors.T);
draw.F_minus = normrnd(priors.f,sqrt(priors.F),1,priors.T+priors.P,priors.P);
for p = 1 : priors.P
    draw.F_minus(:,p+1:priors.T+p,p) = draw.F;
end,
draw.F_minus = draw.F_minus(:,1:priors.T,:);
data.st = draw.F_minus(:,:,1);
%   This is the number of coefficients in each VAR
priors.no_coef = ((priors.N + 1)^2) * priors.P + priors.N + 1;
%   ******************************************************************
%	Priors
%   for OMEGA
priors.R = eye(priors.N + 1);
priors.R(end,end) = 1000000;
priors.rho = 1000;
%   for the VAR coefficients
priors.A = 10 * eye(2 * priors.no_coef-2);
priors.a = zeros(2 * priors.no_coef-2,1);
%   for logistic
priors.c_hi = 1;
priors.c_low = 0.2;
priors.low_thresh = ceil(0.25*priors.T);
priors.hi_thresh = ceil(0.75*priors.T);
priors.gam1 = 6;
priors.gam2 = 1;
priors.delta_gamma = 0.05;
%   for the factor loadings
priors.lam_on = 0.025;
priors.B = 0.01;
priors.b = -100;
%   for the measurement variances
priors.w = 1;
priors.W = 1;
%   *******************************************************
%   Some important parameters
%   *******************************************************
%   The dimension of the state vector
priors.dim_x = priors.P * (priors.N + 1);
%   ******************************************************************
%	Initialize the draw structure
%   ******************************************************************
draw.A1 = zeros(priors.N + 1,(priors.N + 1) * priors.P + 1);
draw.A2 = zeros(priors.N + 1,(priors.N + 1) * priors.P + 1);
draw.OMEGA1 = eye(priors.N + 1);
draw.OMEGA1(end,end) = 0.05;
draw.OMEGA2=draw.OMEGA1; 
draw.gamma = 3;
draw.c = 0;
priors.sc=sqrt(.1);
draw.phi_val = (1 + exp(-draw.gamma * (data.st - draw.c * ones(1,priors.T)))) .^ (-1);
%draw.beta = zeros(priors.N_x,1);
draw.sig = 0.5 * ones(priors.N_x,1);
draw.lam = ones(priors.N_x,1);
draw.acc = 0;

