

function [IR1,IR2] = gen_resp_unb_v2(data, priors,draw,sh, rep)
%rep is the number of the replications to compute the conditional means
%this is for a financial stress shock of size sh for a specific set of
%v=[zeros(priors.N,1); sh]; 
%works only for p=1
%getting a output shock
%csigma=chol(draw.OMEGA)';
%v=(csigma(:,1)./csigma(1,1))*sh; 
%getting inflation shock
%csigma=chol(draw.OMEGA)';
%v=(csigma(:,2)./csigma(2,2))*sh 
%selecting histories
n1=sum(draw.phi_val(priors.P+1:priors.T)<=0.50); 
n2=sum(draw.phi_val(priors.P+1:priors.T)>0.50); 
%a standard deviation shock
% csigma=sqrt((n1*draw.OMEGA1(3,3)+n2*draw.OMEGA2(3,3))/(n1+n2));
% v=[zeros(priors.N,1); csigma]; 
% v1=v; v2=v; 
%IP shock
csigma=((n1*draw.OMEGA1+n2*draw.OMEGA2)/(n1+n2));
csigma1=chol(csigma)';
v1=-1*(csigma1(:,1)./csigma1(1,1)); %one standard deviation shock
v2=v1

X1s=[];
X2s=[];
for t = priors.P+1:priors.T
     Xt=[];
      for p = 1:priors.P
            X_minus = [data.Y_minus(:,t,p); draw.F_minus(:,t,p)];
            Xt = [Xt X_minus];
         end,
       if draw.phi_val(t)<=0.50 
         X1s = cat(3,X1s,Xt);
       elseif draw.phi_val(t)>0.50
          X2s = cat(3,X2s,Xt);
        end,  
end,
n1=sum(draw.phi_val(priors.P+1:priors.T)<=0.50) 
n2=sum(draw.phi_val(priors.P+1:priors.T)>0.50) 

%first regime
irh1 = zeros((priors.N+1),priors.H,n1);
for ii = 1:n1
    ys=zeros(priors.N+1,priors.H+priors.P);
    xi=X1s(:,1:priors.P,ii);
    ys(:,1:priors.P)=xi(:,priors.P:-1:1);
    yns=ys; 
     %impact
    irs=zeros((priors.N+1),priors.H,rep);
    irns=zeros((priors.N+1),priors.H,rep);
    for nr=1:rep 
      %ei=(mvnrnd(zeros(1,priors.N+1),draw.OMEGA))';
        tfi=1/(1+exp(-(draw.gamma/draw.sc)*(ys(priors.N+1,priors.P)-draw.c))); 
        yis=ys(:,priors.P:-1:1);
        ys(:,priors.P+1)=(1-tfi)*draw.A1*([1;yis(:)])+ tfi*(draw.A1+draw.A2)*([1;yis(:)])+v1;
        yns(:,priors.P+1)=(1-tfi)*draw.A1*([1;yis(:)]) + tfi*(draw.A1+draw.A2)*([1;yis(:)]);
        for jj=2:priors.H
        cjj=jj;    
        tfis=1/(1+exp(-(draw.gamma/draw.sc)*(ys(priors.N+1,priors.P+jj-1)-draw.c)));
        OMEGA_tfis = (1 - tfis) * draw.OMEGA1 + tfis * draw.OMEGA2;
        ei=(mvnrnd(zeros(1,priors.N+1),OMEGA_tfis))';
        ys(:,priors.P+cjj)=(1-tfis)*draw.A1*([1;ys(:,priors.P+cjj-1:-1:cjj)]) + tfis*(draw.A1+draw.A2)*([1;ys(:,priors.P+cjj-1:-1:cjj)])+ei;
        tfins=1/(1+exp(-(draw.gamma/draw.sc)*(yns(priors.N+1,priors.P+cjj-1)-draw.c)));
        OMEGA_tfins = (1 - tfins) * draw.OMEGA1 + tfins * draw.OMEGA2;
        ei=(mvnrnd(zeros(1,priors.N+1),OMEGA_tfins))';
        yns(:,priors.P+cjj)=(1-tfins)*draw.A1*([1;yns(:,priors.P+cjj-1:-1:cjj)]) + tfins*(draw.A1+draw.A2)*([1;yns(:,priors.P+cjj-1:-1:cjj)])+ei;
        end,
        cnr=nr; 
   irs(:,:,cnr)=ys(:,priors.P+1:priors.P+priors.H); 
  irns(:,:,cnr)=yns(:,priors.P+1:priors.P+priors.H);
  end, 
irh1(:,:,ii)=(mean(irs,3)-mean(irns,3));  
end,
IR1=mean(irh1,3);

%second regime
irh2 = zeros((priors.N+1),priors.H,n2);
for ii = 1:n2
    ys=zeros(priors.N+1,priors.H+priors.P);
    xi=X2s(:,1:priors.P,ii);
    ys(:,1:priors.P)=xi(:,priors.P:-1:1);
    yns=ys; 
     %impact
    irs=zeros((priors.N+1),priors.H,rep);
    irns=zeros((priors.N+1),priors.H,rep);
      for nr=1:rep 
      %ei=(mvnrnd(zeros(1,priors.N+1),draw.OMEGA))';
         tfi=1/(1+exp(-(draw.gamma/draw.sc)*(ys(priors.N+1,priors.P)-draw.c))); 
        yis=ys(:,priors.P:-1:1);
        ys(:,priors.P+1)=(1-tfi)*draw.A1*([1;yis(:)])+ tfi*(draw.A1+draw.A2)*([1;yis(:)])+v2;
        yns(:,priors.P+1)=(1-tfi)*draw.A1*([1;yis(:)]) + tfi*(draw.A1+draw.A2)*([1;yis(:)]);
        for jj=2:priors.H
          tfis=1/(1+exp(-(draw.gamma/draw.sc)*(ys(priors.N+1,priors.P+jj-1)-draw.c)));
        OMEGA_tfis = (1 - tfis) * draw.OMEGA1 + tfis * draw.OMEGA2;
        yis=ys(:,priors.P+jj-1:-1:jj);
        ys(:,priors.P+jj)=(1-tfis)*draw.A1*([1;yis(:)]) + tfis*(draw.A1+draw.A2)*([1;yis(:)])+ei;
        yins=yns(:,priors.P+jj-1:-1:jj);
        tfins=1/(1+exp(-(draw.gamma/draw.sc)*(yns(priors.N+1,priors.P+jj-1)-draw.c)));
         OMEGA_tfins = (1 - tfins) * draw.OMEGA1 + tfins * draw.OMEGA2;
        ei=(mvnrnd(zeros(1,priors.N+1),OMEGA_tfins))';
        yns(:,priors.P+jj)=(1-tfins)*draw.A1*([1;yins(:)]) + tfins*(draw.A1+draw.A2)*([1;yins(:)])+ei;
      end,
  irs(:,:,nr)=ys(:,priors.P+1:priors.P+priors.H); 
  irns(:,:,nr)=yns(:,priors.P+1:priors.P+priors.H);
  end, 
irh2(:,:,ii)=(mean(irs,3)-mean(irns,3));  
end,

IR2=mean(irh2,3);
    
