

function [A1,A2] = draw_A_F(r,R,priors)
%   zappa is the number of columns in one regime's worth of A
zappa = 1 + (1 + priors.N) * priors.P;
ne=priors.N+1; %number of endogenous variables
X = r + chol(R,'lower') * normrnd(0,1,size(r,1),1);
A = zeros(priors.N + 1,2 * zappa);
for n = 1:priors.N+1
    A(n,:) = X((n - 1) * 2 * (zappa) + 1:n * 2 * zappa,1)';
end,

%works with p=1
% A(priors.N+1,1+ne) = X(zappa*(priors.N*2)+1,1);
% A(priors.N+1,zappa+1+ne) = X(zappa*(priors.N*2)+2,1);
A1 = A(:,1:zappa);
A2 = A(:,1 + zappa:end);
