function [gama,c,phi_val,A,acc] = fastar_GAMMA_RDH(draw,priors,data)

star.a = (draw.gamma ^ 2) / priors.delta_gamma;
star.b =  draw.gamma / priors.delta_gamma;
%   this prevents drawing gamma == 0
accept = 0;count = 1;
while accept == 0
    star.gamma = gamrnd(star.a , 1 / star.b);
    if star.gamma > 1 %0.00001
        accept = 1;
    else
        count = count + 1;
    end,
    if count > 1000
        accept = 1;
        star.gamma = eps;
    end,
end
facts = sort(draw.F);
star.c_low = facts(1,priors.low_thresh);
star.c_hi = facts(1,priors.hi_thresh);
star.c = unifrnd(star.c_low,star.c_hi);
star.sc=std(data.st(:,20:end),1,2);

star.phi_val = (1 + exp(-(star.gamma/star.sc) * (data.st - star.c * ones(1,priors.T)))) .^ (-1);
%   A is constructed so that the first element is the intercept, then it
%   goes by lags (i.e., all lag 1, all lag 2...
XX = ones(priors.T,1);
for p = 1:priors.P
    for n = 1:priors.N
        XX = [XX data.Y_minus(n,:,p)'];
    end,
    for k = 1:1
        XX = [XX draw.F_minus(k,:,p)'];
    end,
end,
%   errors
star.z = zeros(priors.T,priors.N+1);
draw.z = zeros(priors.T,priors.N+1);
for t = 1:priors.T
    star.z(t,:) = XX(t,:) * draw.A1' + star.phi_val(1,t) .* XX(t,:) * draw.A2';
    draw.z(t,:) = XX(t,:) * draw.A1' + draw.phi_val(1,t) .* XX(t,:) * draw.A2';
end,
YY = [data.Y' , draw.F'];
star.e = YY - star.z;
draw.e = YY - draw.z;

[A] = fastar_MH_acceptance_RDH(draw,priors,star);
u = rand(1);
if u <= A;
    gama = star.gamma;
    c = star.c;
    phi_val = star.phi_val;
    acc = 1;
else
    gama = draw.gamma;
    c = draw.c;
    phi_val = draw.phi_val;
    acc = 0;
end,

