
function [draw,acc] = fastar_OMEGA_2_RDH(draw,priors,data)
%   **************************************************************
%   Draw proposals from the Wishart
%   **************************************************************
%   Compute the hyperparameters
%   **************************************************************
T2 = priors.T - sum(draw.F_minus < draw.c);
nu2 = T2 + priors.rho;
%   **************************************************************
sumYmXb2 = 0;
star.resid = zeros(priors.N+1,priors.T);
for t = 1:priors.T
    Xst = 1;
    for p = 1:priors.P
        Xst = [Xst data.Y_minus(:,t,p)' draw.F_minus(:,t,p)'];
    end,
    for n = 1:priors.N
        star.resid(n,t) = data.Y(n,t) - draw.A1(n,:) * Xst';
        star.resid(n,t) = star.resid(n,t) - draw.phi_val(1,t) * draw.A2(n,:) * Xst';
    end,
    for n = 1 + priors.N:1 + priors.N
        star.resid(n,t) = draw.F(n-priors.N,t) - draw.A1(n,:) * Xst';
        star.resid(n,t) = star.resid(n,t) - draw.phi_val(1,t) * draw.A2(n,:) * Xst';
    end,
% sumYmXb2 = sumYmXb2 + (1 - draw.phi_val(1,t)) * star.resid(:,t) * star.resid(:,t)';% should it be draw.phi_val(1,t)????
 sumYmXb2 = sumYmXb2 + (draw.phi_val(1,t)) * star.resid(:,t) * star.resid(:,t)';
end
%   *************************************************************
R2 = inv(inv(priors.R) + sumYmXb2);

%   Draw the candidate
x = chol(R2)' * chol(R2);
star.inv_OMEGA2 = wishrnd(priors.del_x2 * x,nu2 / priors.del_x2);
star.OMEGA2 = inv(star.inv_OMEGA2);
%   *************************************************************
%   Accept or rejct the candidate
%   *************************************************************
%   Compute the ratio of the likelihoods
star.OMEGA = zeros(priors.N+1,priors.N+1,priors.T);
star.like = 0;
for t = 1 : priors.T
    %   Compute the sequence of OMEGAs based on the two
%     star.OMEGA(:,:,t) = draw.OMEGA1 * draw.phi_val(:,t) + (1 - draw.phi_val(:,t)) * star.OMEGA2;
    star.OMEGA(:,:,t) = draw.OMEGA1 * (1-draw.phi_val(:,t)) + ( draw.phi_val(:,t)) * star.OMEGA2;
    star.like = - logdet(star.OMEGA(:,:,t)) / 2;
    star.like = star.like - star.resid(:,t)' * inv(star.OMEGA(:,:,t)) * star.resid(:,t);
end,
draw.OMEGA = zeros(priors.N+1,priors.N+1,priors.T);
draw.like = 0;
for t = 1 : priors.T
    %   Compute the sequence of OMEGAs based on the two
%     draw.OMEGA(:,:,t) = draw.OMEGA1 * draw.phi_val(:,t) + (1 - draw.phi_val(:,t)) * draw.OMEGA2;
    draw.OMEGA(:,:,t) = draw.OMEGA1 * (1-draw.phi_val(:,t)) + (draw.phi_val(:,t)) * draw.OMEGA2;
    draw.like = - logdet(draw.OMEGA(:,:,t)) / 2;
    draw.like = draw.like - star.resid(:,t)' * inv(draw.OMEGA(:,:,t)) * star.resid(:,t);
end,
%   Compute the ratio of the priors
star.prior = log_wish_pdf(inv(star.OMEGA2), priors.rho, inv(priors.R));
%   Compute the ratio of the move probabilities
% % move_draw = log_wish_pdf(draw.inv_OMEGA2,nu2 / priors.del_x,priors.del_x * R2);
% % move_star = log_wish_pdf(star.inv_OMEGA2,nu2 / priors.del_x,priors.del_x * R2);

[draw.move] = log_wish_pdf(draw.OMEGA2, nu2 / priors.del_x2, x * priors.del_x2);
[star.move] = log_wish_pdf(star.OMEGA2, nu2 / priors.del_x2, x * priors.del_x2);

top = [star.like, star.prior, draw.move];%, move_draw];
%disp(top)
bot = [draw.like, draw.prior2, star.move];%, move_star];
%disp(bot)
%error('stop')
a = min([1,exp(sum(top) - sum(bot))]);
u = rand;
if u < a
    draw.OMEGA2 = star.OMEGA2;
    %draw.inv_OMEGA2 = star.inv_OMEGA2;
    draw.OMEGA = star.OMEGA;
    acc = 1;
else
    acc = 0;
end,