function [priors,draw,results,data] = fastar_priors_RDH(datanam)
%   ******************************************************************
%   Set up the sampler
%   ******************************************************************
priors.burn = 5000;
priors.keep = 20000;
priors.P = 1;
priors.H = 24;
priors.Hf=12; 
priors.Hfc=(1:200:priors.keep)';
[nf,nc]=size(priors.Hfc);
priors.nf=nf; 
priors.datanam = datanam;
%   ******************************************************************
%   Load the data
data.Y = xlsread(priors.datanam,'Sheet2');
% data.Y = data.Y(1:344,3:end)';
data.Y = data.Y(1:end,3:end)';
[priors.N,T] = size(data.Y);
%   make lags of the data
data.Y_minus = zeros(priors.N,T,priors.P);
for p = 1:priors.P
    data.Y_minus(:,1+p:end,p) = data.Y(:,1:end-p);
end,
data.Y_minus = data.Y_minus(:,1+priors.P:end,:);
data.Y = data.Y(:,1+priors.P:end);
priors.T = size(data.Y,2);
priors.f = 0;
priors.F = 1;
data.x = xlsread(priors.datanam,'Sheet1');
data.x = data.x(1:end,3:end)';
% data.x = data.x(1:344,3:end)';
data.X = data.x(:,1+priors.P:end);
priors.N_x = size(data.x,1);
priors.start_x = zeros(priors.N_x,1);
for n_x = 1:priors.N_x
    t_start = find(isnan(data.X(n_x,:)),1,'last');
    if isempty(t_start) == 1
        priors.start_x(n_x,1) = 1;
    else
        priors.start_x(n_x,1) = t_start + 1;
    end,
end,

%[draw.F,draw.beta] = pca(data.X',1);
%[draw.F,draw.beta] = pca(data.X(:,266:end)',1);
%[draw.F,draw.beta] = pca(data.X(:,101:end)',1);
%for new dataset
draw.beta=[0.174441941688819;-0.00422061072785408;0.00951816539271698;0.0180863776405756;0.206821636056657;0.0653613607183571;0.0190348713285732;0.0522492510907822;0.0350917605176413;0.289298412778400;0.0762055460746468;0.0111831964328832;0.158556055708216;-0.0223894589010223;0.307157805115116;0.328152010533408;0.0862174462305808;0.0371040855437701;1.72956402489342;0.0487339569374647;0.0678957630685903;0.781605796543054;0.305751419251706];

draw.F=draw.beta'*data.X;
%draw.F = -draw.F;
%draw.beta = -draw.beta;
%draw.lam = ones(priors.N_x,1);
%draw.lam=[1;1;0;0;1;1;1;1;0;1;1;1;1;1;1;1;1;1];
draw.lam=[1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1];% if new data; based on linear model
draw.sig = 0.5 * ones(priors.N_x,1);
draw.sig=[3.61681370545798;0.193721754072816;0.405669601427256;1.14428955440950;0.297713298929633;0.162245757431049;0.329680801107370;0.147701581033534;0.353165597614722;2.27450693618664;0.357497849907180;0.0965013654096631;1.59002341903502;0.376252461183781;9.21332359511585;2.63995235862518;7.41861537177543;1.83549554131276;83.6479748055723;0.198343934422700;0.124894627267092;4.62304316896878;12.6609013191421];%if new data
draw.F = normrnd(priors.f,sqrt(priors.F),1,priors.T);
draw.F_minus = normrnd(priors.f,sqrt(priors.F),1,priors.T+priors.P,priors.P);
for p = 1 : priors.P
    draw.F_minus(:,p+1:priors.T+p,p) = draw.F;
end,
draw.F_minus = draw.F_minus(:,1:priors.T,:);
data.st = draw.F_minus(:,:,1);
%   This is the number of coefficients in each VAR
priors.no_coef = ((priors.N + 1)^2) * priors.P + priors.N + 1;
priors.no_coef_macro = (priors.N * (priors.N + 1)) * priors.P + priors.N;
priors.no_coef_factor = priors.P;
priors.no_coef_new = priors.no_coef_macro + priors.no_coef_factor;
%   ******************************************************************
%	Priors
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%   for OMEGA
priors.R = 0.1 * eye(priors.N + 1);
priors.R(end,end) = 1000;
priors.rho = 1000;%1000;
%priors.rho = 15;
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%   for the VAR coefficients
priors.A = 10*eye(2 * priors.no_coef_new);
priors.a = zeros(2 * priors.no_coef_new,1);
%   for logistic
priors.c_hi = 1;
priors.c_low = 0.2;
priors.low_thresh = ceil(0.50*priors.T);
priors.hi_thresh = ceil(0.90*priors.T);

priors.gam1 = 6;%6
priors.gam2 = 3;%1%3
priors.delta_gamma = 0.001; %0.2; this has to be large .5, or p=4 gets stuck for p=2, .2 is better; previous version =.05
%   for the factor loadings
priors.lam_on = 0.01;
priors.B = 0.01;
priors.b = -100;
%   for the measurement variances
priors.w = 1;
priors.W = 100;
%   *******************************************************
%   Some important parameters
%   *******************************************************
%   The dimension of the state vector
priors.dim_x = priors.P * (priors.N + 1);
%   ******************************************************************
%	Initialize the draw structure
%   ******************************************************************
draw.A1 = zeros(priors.N + 1,(priors.N + 1) * priors.P + 1);
draw.A2 = zeros(priors.N + 1,(priors.N + 1) * priors.P + 1);
draw.gamma = 15;
draw.c = 1;
priors.sc=sqrt(1); %this is a scaler for the transition function;
draw.sc=priors.sc; 
draw.phi_val = (1 + exp(-((draw.gamma/priors.sc) * (data.st - draw.c * ones(1,priors.T))))) .^ (-1);
%draw.beta = zeros(priors.N_x,1);
draw.acc = 0;
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
draw.OMEGA1 = 1*eye(priors.N + 1);
draw.OMEGA1(end,end) = 1;%.10
draw.OMEGA2 = 1* eye(priors.N + 1);
draw.OMEGA2(end,end) = 1;%.10
draw.OMEGA = zeros(priors.N + 1,priors.N + 1,priors.T);
for t = 1 : priors.T
    draw.OMEGA(:,:,t) = (1 - draw.phi_val(:,t)) * draw.OMEGA1 + draw.phi_val(:,t) * draw.OMEGA2;
end,
priors.del_x1 = 150; %200 for full sample and 100 for shorter samples
priors.del_x2 = 150;
draw.acc1 = 0;
draw.acc2 = 0;
draw.resid = zeros(priors.N+1,priors.T);
for t = 1:priors.T
    Xst = 1;
    for p = 1:priors.P
        Xst = [Xst data.Y_minus(:,t,p)' draw.F_minus(:,t,p)'];
    end,
    for n = 1:priors.N
        draw.resid(n,t) = data.Y(n,t) - draw.A1(n,:) * Xst';
        draw.resid(n,t) = draw.resid(n,t) - draw.phi_val(1,t) * draw.A2(n,:) * Xst';
    end,
    for n = 1 + priors.N:1 + priors.N
        draw.resid(n,t) = draw.F(n-priors.N,t) - draw.A1(n,:) * Xst';
        draw.resid(n,t) = draw.resid(n,t) - draw.phi_val(1,t) * draw.A2(n,:) * Xst';
    end,
end,
draw.prior1 = log_wish_pdf(inv(draw.OMEGA1),priors.rho,priors.R);
draw.prior2 = log_wish_pdf(inv(draw.OMEGA2),priors.rho,priors.R);
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%   ******************************************************************
%   Storage
%   ******************************************************************
results.A1 = zeros(priors.N + 1,(priors.N + 1)*priors.P+1,priors.keep);
results.A2 = zeros(priors.N + 1,(priors.N + 1)*priors.P+1,priors.keep);
results.OMEGA1 = zeros(priors.N + 1,priors.N + 1,priors.keep);
results.OMEGA2 = zeros(priors.N + 1,priors.N + 1,priors.keep);
results.gamma = zeros(1,priors.keep);
results.lam = zeros(priors.N_x,priors.keep);
results.c = zeros(1,priors.keep);
results.phi_val = zeros(priors.T,priors.keep);
results.F = zeros(1,priors.T,priors.keep);
results.beta = zeros(priors.N_x,priors.keep);
results.lam = zeros(priors.N_x,priors.keep);
results.sig = zeros(priors.N_x,priors.keep);
results.yf = zeros(priors.N+1,priors.Hf,priors.nf);
results.tf = zeros(1,priors.Hf,priors.nf);