function [log_wish_pdf] = log_wish_pdf(W, nu, V)
nu = ceil(nu);
d = size(V,1);

numerator1 = ((nu - d - 1) / 2)*logdet(W);
numerator2 = -0.5 * trace(inv(V) * W);

denominator1 = ((nu * d) / 2)*log(2);
denominator2 = (nu / 2)*logdet(V);
denom_gamma = (d * (d - 1) / 4)*log(pi);

denom_product = 0; %change to zero for log
for p = 1:d
    denom_product = denom_product + gammaln((nu/2)+(1-p)/2);
end

denominator3 = denom_gamma + denom_product;

log_wish_pdf = numerator1 + numerator2 - (denominator1 + denominator2 + denominator3);

% % % % 
% % % % d = size(V,1);
% % % % 
% % % % numerator1 = det(W)^((nu - d - 1) / 2);
% % % % numerator2 = exp(-0.5 * trace(inv(V) * W));
% % % % 
% % % % denominator1 = 2^((nu * d) / 2);
% % % % denominator2 = det(V)^(nu / 2);
% % % % denom_gamma = pi^(d * (d - 1) / 4);
% % % % 
% % % % denom_product = 1;
% % % % for p = 1:d
% % % %     denom_product = denom_product * gamma((nu/2)+(1-p)/2);
% % % % end
% % % % 
% % % % denominator3 = denom_gamma * denom_product;
% % % % 
% % % % wish_pdf = (numerator1 * numerator2) / (denominator1 * denominator2 * denominator3);