% Extracts first k principal components
% Input: Txn matrix of data THAT HAS ALREADY BEEN STANDARDIZED TO MEAN 0 AND SD 1
% Factor loadings are normalized so that lam'lam/n=I
% Matrix of eigenvectors, lam, is n*k
% Normalized data fact is T*k

function [fact,lam] = pca(data,k)
[T,n] = size(data);
sighat = cov(data);
[eigvec,eigval] = eig(sighat);
[eigval,index] = sort(diag(eigval), 'descend');


sorteigvec = zeros(n);
for i=1:n
   sorteigvec(:,i) = eigvec(:,index(i));
end

lam = sqrt(n)*sorteigvec(:,1:k);
fact=data*lam/n;
